<?php
function _contactUpdate()
{
	global $objDatabase, $_ARRAYLANG, $_CONFIG, $objUpdate, $_CORELANG;

	$arrColumns = $objDatabase->MetaColumnNames(DBPREFIX."module_contact_form");
	if (!is_array($arrColumns)) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_contact_form'));
		return false;
	}

	if (!in_array("subject", $arrColumns)) {
		$query = "ALTER TABLE ".DBPREFIX."module_contact_form ADD `subject` VARCHAR( 255 ) NOT NULL DEFAULT '' AFTER `mails`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	} else {
		$query = "ALTER TABLE ".DBPREFIX."module_contact_form CHANGE `subject` `subject` VARCHAR( 255 ) NOT NULL DEFAULT ''";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (!in_array("text", $arrColumns)) {
		$query = "ALTER TABLE ".DBPREFIX."module_contact_form ADD `text` TEXT NOT NULL AFTER `subject`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (!in_array("feedback", $arrColumns)) {
		$query = "ALTER TABLE ".DBPREFIX."module_contact_form ADD `feedback` TEXT NOT NULL AFTER `text`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (in_array('langId', $arrColumns)) {
		// this is a fix for the next step caused of an older update script which had set the langId to 0 when the browser didn't suported ajax
		$query = "SELECT id, name FROM ".DBPREFIX."module_contact_form WHERE langId=0";
		$objResult = $objDatabase->Execute($query);
		if ($objResult !== false) {
			if ($objResult->RecordCount() > 0) {
				$formsWithoutLang = true;
				$arrContactForms = array();
				while (!$objResult->EOF) {
					if (isset($_POST['contactForm'])) {
						$arrContactForms[$objResult->fields['id']] = intval($_POST['contactForm'][$objResult->fields['id']]);
					} else {
						$arrContactForms[$objResult->fields['id']] = $objResult->fields['name'];
					}
					$objResult->MoveNext();
				}
			} else {
				$formsWithoutLang = false;
			}
		} else {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (!in_array("langId", $arrColumns) || $formsWithoutLang || (isset($_SESSION['contrexx_update']['update']['contact']['setLangId']) && $_SESSION['contrexx_update']['update']['contact']['setLangId'])) 	{
		$query = "SELECT id, name, `charset` FROM ".DBPREFIX."languages WHERE frontend=1";
		$objResult = $objDatabase->Execute($query);
		if ($objResult !== false) {
			if ($objResult->RecordCount() > 1) {
				$arrLanguages = array();
				while (!$objResult->EOF) {
					$arrLanguages[$objResult->fields['id']] = array(
						'name'	=> $objResult->fields['name'],
						'charset'	=> $objResult->fields['charset']
					);
					$objResult->MoveNext();
				}

				if (!$formsWithoutLang) {
					$query = "SELECT id, name FROM ".DBPREFIX."module_contact_form";
					$objResult = $objDatabase->Execute($query);
					if ($objResult !== false) {
						$arrContactForms = array();
						while (!$objResult->EOF) {
							if (isset($_POST['contactForm'])) {
								$arrContactForms[$objResult->fields['id']] = intval($_POST['contactForm'][$objResult->fields['id']]);
							} else {
								$arrContactForms[$objResult->fields['id']] = $objResult->fields['name'];
							}
							$objResult->MoveNext();
						}
					} else {
						return _databaseError($query, $objDatabase->ErrorMsg());
					}
				}

				if (!isset($_POST['contactForm'])) {
					$msg = htmlspecialchars(count($arrContactForms)>1 ? $_ARRAYLANG['TXT_SELECT_CONTACT_FORMS_LANG'] : $_ARRAYLANG['TXT_SELECT_CONTACT_FORM_LANG'])."<br /><br />\n"
						."<table cellpadding='2' cellspacing='0' border='0'>\n"
						."<tbody>\n"
						."<tr>\n"
						."<th>ID</th><th>Name</th><th>Sprache</th>\n"
						."</tr>\n";

					foreach ($arrContactForms as $id => $name) {
						$msg .= "<tr>\n"
							."<td>".$id."</td>\n"
							."<td>".htmlspecialchars($name)."</td>\n"
							."<td>\n<select name='contactForm[".$id."]' size='1'>\n";
						foreach ($arrLanguages as $languageId => $arrLanguage) {
							$msg .= "<option value='".$languageId."'>".$arrLanguage['name']." (".$arrLanguage['charset'].")</option>\n";
						}
						$msg .= "</select>\n</td>\n"
							."</tr>\n";
					}

					$msg .= "</tbody>\n"
						."</table>\n"
						."<br />\n";

					setUpdateMsg($_ARRAYLANG['TXT_CONFIG_CONTACT_FORMS'], 'title');
					setUpdateMsg($msg, 'msg');
					setUpdateMsg('<input type="submit" value="Kontaktformular'.((count($arrContactForms)>1) ? 'e' : '').' aktualisieren" name="updateNext" /><input type="hidden" name="processUpdate" id="processUpdate" />', 'button');
					return false;
				}
			} elseif ($objResult->RecordCount() == 1) {
				$langId = $objResult->fields['id'];
			} else {
				$langId = 1;
			}

			if (isset($langId) || isset($_POST['contactForm'])) {
				if (!in_array("langId", $arrColumns)) {
					$query = "ALTER TABLE ".DBPREFIX."module_contact_form ADD `langId` TINYINT( 2 ) UNSIGNED DEFAULT '1' NOT NULL AFTER `feedback`";
					if ($objDatabase->Execute($query) === false) {
						return _databaseError($query, $objDatabase->ErrorMsg());
					}
				}

				if (isset($langId)) {
					$query = "UPDATE ".DBPREFIX."module_contact_form SET `langId`=".$langId;
					if ($objDatabase->Execute($query) === false) {
						$_SESSION['contrexx_update']['update']['contact']['setLangId'] = true;
						return _databaseError($query, $objDatabase->ErrorMsg());
					}
				} else {
					foreach ($arrContactForms as $id => $langId) {
						$query = "UPDATE ".DBPREFIX."module_contact_form SET `langId`=".$langId." WHERE id=".$id;
						if ($objDatabase->Execute($query) === false) {
							$_SESSION['contrexx_update']['update']['contact']['setLangId'] = true;
							return _databaseError($query, $objDatabase->ErrorMsg());
						}
					}
				}
				if (isset($_SESSION['contrexx_update']['update']['contact']['setLangId']) && $_SESSION['contrexx_update']['update']['contact']['setLangId']) {
					$_SESSION['contrexx_update']['update']['contact']['setLangId'] = false;
				}
			}
		} else {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (!in_array("showForm", $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."module_contact_form` ADD `showForm` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0' AFTER `feedback`"	;
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

    if (!in_array("use_captcha", $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."module_contact_form` ADD `use_captcha` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '1' AFTER `showForm`";

		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}

		$query = "UPDATE `".DBPREFIX."module_contact_form` SET `use_captcha` = '0'";
		$objDatabase->Execute($query);
	}

	if (!in_array("use_custom_style", $arrColumns)) {
		$query = "ALTER TABLE `".DBPREFIX."module_contact_form` ADD `use_custom_style` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '0' AFTER `use_captcha`";

		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}

		$query = "UPDATE `".DBPREFIX."module_contact_form` SET `use_custom_style` = '0'";
		$objDatabase->Execute($query);
	}

	$arrColumns = null;
	$arrColumns = $objDatabase->MetaColumnNames(DBPREFIX."module_contact_form_field");
	if (!is_array($arrColumns)) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_contact_form_field'));
		return false;
	}

	if (!in_array("is_required", $arrColumns)) {
		$query = "ALTER TABLE ".DBPREFIX."module_contact_form_field ADD `is_required` SET( '0', '1' ) DEFAULT '0' NOT NULL AFTER `attributes`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if (!in_array("check_type", $arrColumns)) {
		$query = "ALTER TABLE ".DBPREFIX."module_contact_form_field ADD `check_type` INT( 3 ) DEFAULT '1' NOT NULL AFTER `is_required`";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	$query = "ALTER TABLE `".DBPREFIX."module_contact_form_field` CHANGE `type` `type` ENUM( 'text', 'label', 'checkbox', 'checkboxGroup', 'date', 'file', 'hidden', 'password', 'radio', 'select', 'textarea' ) NOT NULL DEFAULT 'text'";
	if ($objDatabase->Execute($query) === false) {
		return _databaseError($query, $objDatabase->ErrorMsg());
	}

	$arrContactSettings = array(
		'spamProtectionWordList'	=> 'poker,casino,viagra,sex,porn,pussy,fucking',
		'fieldMetaDate'				=> '0',
		'fieldMetaHost'				=> '0',
		'fieldMetaLang'				=> '0',
		'fieldMetaIP'				=> '0'
	);

	foreach ($arrContactSettings as $setname => $setvalue) {
		$query = "SELECT setid FROM ".DBPREFIX."module_contact_settings WHERE setname='".$setname."'";
		$objResult = $objDatabase->SelectLimit($query, 1);

		if ($objResult !== false) {
			if ($objResult->RecordCount() == 0) {
				$query = "INSERT INTO ".DBPREFIX."module_contact_settings ( `setid` , `setname` , `setvalue` , `status` ) VALUES ('', '".$setname."', '".$setvalue."', '1')";
				if ($objDatabase->Execute($query) === false) {
					return _databaseError($query, $objDatabase->ErrorMsg());
				}
			}
		} else {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}

	}

    $query = "
    ALTER TABLE ".DBPREFIX."module_contact_settings
    CHANGE COLUMN setid setid integer(6) UNSIGNED NOT NULL auto_increment
    ";
    if (!$objDatabase->Execute($query)) {
    	return _databaseError($query, $objDatabase->ErrorMsg());
    }

    $arrColumns = $objDatabase->MetaColumns(DBPREFIX.'module_contact_form');
	if ($arrColumns === false) {
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UNABLE_GETTING_DATABASE_TABLE_STRUCTURE'], DBPREFIX.'module_contact_form'));
		return false;
	}

	if (empty($arrColumns['SEND_COPY'])) {
		$query = " ALTER TABLE `".DBPREFIX."module_contact_form` ADD `send_copy` INT( 1 ) NOT NULL DEFAULT '0'";
		if ($objDatabase->Execute($query) === false) {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}

	if ($objUpdate->_isNewerVersion($_CONFIG['coreCmsVersion'], '1.2.0')) {
		$query = 'SELECT `id`, `name` FROM `'.DBPREFIX.'module_contact_form_field`';
		$objContactField = $objDatabase->Execute($query);
		if ($objContactField !== false) {
			while (!$objContactField->EOF) {
				$query = "UPDATE `".DBPREFIX."module_contact_form_field` SET `name` = '".addslashes(html_entity_decode($objContactField->fields['name'], ENT_QUOTES, (UPDATE_UTF8 ? 'UTF-8' : 'ISO-8859-1')))."' WHERE `id` = ".$objContactField->fields['id'];
				if ($objDatabase->Execute($query) === false) {
					return _databaseError($query, $objDatabase->ErrorMsg());
				}
				$objContactField->MoveNext();
			}
		} else {
			return _databaseError($query, $objDatabase->ErrorMsg());
		}
	}


	//read theme dirs and generate form with all theme checkboxes
	//then update selected themes with the contact CSS styles (see contrexx.com/docs -> contact FAQ)

	if (!empty($_POST['contact_themes_choose'])){
		if(!empty($_POST['themes']) && is_array($_POST['themes'])){
			$_SESSION['contrexx_update']['update']['contact']['arrThemes_to_add_css_styles'] = $_POST['themes'];
		}else{
			$_SESSION['contrexx_update']['update']['contact']['arrThemes_to_add_css_styles'] = array();
		}
	}else{
		foreach (glob(ASCMS_THEMES_PATH.'/*') as $value) {
			if(is_dir($value)){
				$arrThemes[] = $value;
			}
		}
		$cbs = '';
		foreach ($arrThemes as $index => $theme) {
			$name = basename($theme);
			$cbs[] = '<input type="checkbox" name="themes" checked="checked" value="'.$name.'" id="upd_'.$name.'" />
			<label for="upd_'.$name.'">'.$name.'</label>';
		}
		$cbs[] = '<input type="hidden" name="contact_themes_choose" value="1" />';

		$cbsHTMLCheckBoxes = implode('<br />', $cbs);

		setUpdateMsg($_ARRAYLANG['TXT_SELECT_CONTACT_DESIGN_DIRS'], 'title');
		setUpdateMsg(sprintf($_ARRAYLANG['TXT_UPDATE_CONTACT_STYLES'].'<br /><br />', $cbsHTMLCheckBoxes), 'msg');
		setUpdateMsg('<input type="submit" value="'.$_CORELANG['TXT_CONTINUE_UPDATE'].'" name="updateNext" /><input type="hidden" name="processUpdate" id="processUpdate" />', 'button');
		return false;
	}

	$defaultCSS = <<< EOS

/* DEFAULT CONTACT FORM */
form.contactForm p {
	width: 300px;
	clear: left;
	margin: 0;
	padding: 2px 0 3px 0;
	padding-left: 155px;
	_padding-left: 165px;
	height: 1%;
}

form.contactForm p label.noCaption {
	float: left;
	width: 150px;
	margin-left: 2px;
	margin-top: 2px;
}

form.contactForm .contactFormGroup {
	float: left;
	margin-top: -15px !important;
}

form.contactForm p input.contactFormClass_checkbox {
	float: left;
}

form.contactForm p input.contactFormClass_checkboxGroup {
	clear: left;
	float: left;
}

form.contactForm p input.contactFormClass_radio {
	clear: left;
	float: left;
}

form.contactForm p label, .contactForm p span {
	font-weight: bold;
	float: left;
	margin-left: -155px;
	width: 150px;
}

form.contactForm input[type="text"] {
	width: 180px;
}

form.contactForm input{
	overflow: hidden;
}

form.contactForm img.captcha {
	float: left;
}

form.contactForm .is_required {
	color: red;
}

form.contactForm textarea {
	width: 250px;
	height: 150px;
}

form.contactForm #contactFormCaptcha {
	margin-left: 147px;
}


form.contactForm .contactFormClass_button {
	margin-left: 0px;
}

form.contactForm  #contactFormCaptcha {
	margin-left: 3px !important;
	margin-top: 5px !important;
}
EOS;

	// write settings
	if (!@include_once(ASCMS_FRAMEWORK_PATH.'/File.class.php')) {
		setUpdateMsg(sprintf($_CORELANG['TXT_UPDATE_API_LOAD_FAILED'], ASCMS_FRAMEWORK_PATH.'/File.class.php'));
		return false;
	}

	$objFile =& new File();
	$status = true;

	foreach ($_SESSION['contrexx_update']['update']['contact']['arrThemes_to_add_css_styles'] as $theme) {
		$styleFile = ASCMS_THEMES_PATH.'/'.$theme.'/buildin_style.css';
		$appendStyle = true;

		if (!is_writable($styleFile)) {
			$objFile->setChmod(ASCMS_THEMES_PATH.'/'.$theme, ASCMS_PATH_OFFSET.'/themes/'.$theme, '/buildin_style.css');
		}

		if(file_exists($styleFile) && ($tmp = file_get_contents($styleFile)) && preg_match('#/\* DEFAULT CONTACT FORM \*/#', $tmp)){
			$appendStyle = false;
		}

		if($appendStyle){
			$h = @fopen($styleFile, 'w+');
			if(!$h){
				setUpdateMsg(sprintf($_CORELANG['TXT_UPDATE_API_LOAD_FAILED'], $styleFile));
				return false;
			}
			@flock($handleFile, LOCK_EX);
			@fwrite($h, $tmp.$defaultCSS);
			@flock($handleFile, LOCK_UN);
			@fclose($h);

		}
	}
    return true;
}
?>
